<template>
  <div class="input-wrapper">
    <label v-if="label" class="wrapper-label" for="">{{text}}</label>

    <input v-if="type === 'email'" :class="`focus:outline-none focus:border-${color} general-input`" type="email" name="email" :placeholder="text">

    <input v-if="type === 'color'" :class="`focus:outline-none focus:border-${color} general-input`" type="color" name="color" :placeholder="text">

    <input v-if="type === 'text'" :class="`focus:outline-none focus:border-${color} general-input`" type="text" name="text" :placeholder="text">

    <input v-if="type === 'date'" :class="`focus:outline-none focus:border-${color} general-input`" type="date" name="date">

    <input v-if="type === 'password'" :class="`focus:outline-none focus:border-${color} general-input`" type="password" name="password" :placeholder="text">

    <div v-if="type === 'checkbox'" class="checkbox-wrapper">
      <div v-for="option in options" :class="`checkbox-btn ticker-${color}`">
        <input type="checkbox" name="option_checkbox" :id="`cbx-${option}`" style="display: none;" :value="`${option}`">
        <label :for="`cbx-${option}`" class="check">
          <svg width="18px" height="18px" viewBox="0 0 18 18">
            <path d="M1,9 L1,3.5 C1,2 2,1 3.5,1 L14.5,1 C16,1 17,2 17,3.5 L17,14.5 C17,16 16,17 14.5,17 L3.5,17 C2,17 1,16 1,14.5 L1,9 Z"></path>
            <polyline points="1 9 7 14 15 4"></polyline>
          </svg>
        </label>
        <spam class="checkbox-opt">{{ option }}</spam>
      </div>
    </div>

    <div v-if="type === 'radio'" class="checkbox-wrapper">
      <div v-for="option in options" :class="`checkbox-btn ticker-${color}`">
        <input type="radio" name="option_radio" :id="`cbx-${option}`" style="display: none;" :value="`${option}`">
        <label :for="`cbx-${option}`" class="check">
          <svg width="18px" height="18px" viewBox="0 0 18 18">
            <path d="M1,9 L1,3.5 C1,2 2,1 3.5,1 L14.5,1 C16,1 17,2 17,3.5 L17,14.5 C17,16 16,17 14.5,17 L3.5,17 C2,17 1,16 1,14.5 L1,9 Z"></path>
            <polyline points="1 9 7 14 15 4"></polyline>
          </svg>
        </label>
        <spam class="checkbox-opt">{{ option }}</spam>
      </div>
    </div>
  </div>
</template>

<script>
  export default {
    name: "FormInput",
    props: {
      color: {
        type: String,
        default: 'primary'
      },
      text: {
        type: String,
        required: true
      },
      label: {
        type: Boolean,
        default: false
      },
      type: {
        type: String,
        required: true
      },
      options: {
        type: Array,
        required: false
      }
    }
  };
</script>

<style lang="postcss" scoped>
  .checkbox-wrapper {
    display: flex;
    align-items: flex-start;
    flex-direction: column;
    width: 100%;
  }

  .checkbox-wrapper .checkbox-btn {
    margin: 1%;
    display: flex;
    justify-content: flex-start;
    width: 100%;
  }

  .checkbox-wrapper spam.checkbox-opt {
    margin-left: 3%;
  }

  .checkbox-wrapper .check {
    cursor: pointer;
    position: relative;
    width: 18px;
    height: 18px;
    -webkit-tap-highlight-color: transparent;
    transform: translate3d(0, 0, 0);
  }

  .checkbox-wrapper .check svg {
    position: relative;
    z-index: 1;
    fill: none;
    stroke-linecap: round;
    stroke-linejoin: round;

    stroke-width: 1.5;
    transform: translate3d(0, 0, 0);
    transition: all 0.2s ease;
  }

  .checkbox-wrapper .check svg path {
    stroke-dasharray: 60;
    stroke-dashoffset: 0;
  }

  .checkbox-wrapper .check svg polyline {
    stroke-dasharray: 22;
    stroke-dashoffset: 66;
  }

  .checkbox-wrapper input[id^="cbx-"]:checked+.check svg path {
    stroke-dashoffset: 60;
    transition: all 0.3s linear;
  }

  .checkbox-wrapper input[id^="cbx-"]:checked+.check svg polyline {
    stroke-dashoffset: 42;
    transition: all 0.2s linear;
    transition-delay: 0.15s;
  }

  label.wrapper-label {
    margin-left: 1.5%;
  }

  .input-wrapper {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    margin: 5%;
  }

  .general-input {
    border: 1px solid config('colors.grey-light');
    border-radius: 4px;
    background-color: config('colors.white');
    box-sizing: border-box;
    padding: 6px 12px;
    margin-top: 1%;
    width: 100%;
  }

  /* Set color */
  .ticker-primary .check svg {
    stroke: config('colors.primary');
  }

  .ticker-primary .check:hover svg {
    stroke: config('colors.primary');
  }

  .ticker-primary #cbx:checked+.check svg {
    stroke: config('colors.primary');
  }

  .ticker-secondary .check svg {
    stroke: config('colors.secondary');
  }

  .ticker-secondary .check:hover svg {
    stroke: config('colors.secondary ');
  }

  .ticker-secondary #cbx:checked+.check svg {
    stroke: config('colors.secondary ');
  }

  .ticker-light .check svg {
    stroke: config('colors.light');
  }

  .ticker-light .check:hover svg {
    stroke: config('colors.light');
  }

  .ticker-light #cbx:checked+.check svg {
    stroke: config('colors.light');
  }

  .ticker-medium .check svg {
    stroke: config('colors.medium');
  }

  .ticker-medium .check:hover svg {
    stroke: config('colors.medium');
  }

  .ticker-medium #cbx:checked+.check svg {
    stroke: config('colors.medium');
  }

  .ticker-dark .check svg {
    stroke: config('colors.dark');
  }

  .ticker-dark .check:hover svg {
    stroke: config('colors.dark');
  }

  .ticker-dark #cbx:checked+.check svg {
    stroke: config('colors.dark');
  }

  .ticker-success .check svg {
    stroke: config('colors.success');
  }

  .ticker-success .check:hover svg {
    stroke: config('colors.success');
  }

  .ticker-success #cbx:checked+.check svg {
    stroke: config('colors.success');
  }

  .ticker-danger .check svg {
    stroke: config('colors.danger');
  }

  .ticker-danger .check:hover svg {
    stroke: config('colors.danger');
  }

  .ticker-danger #cbx:checked+.check svg {
    stroke: config('colors.danger');
  }
</style>